# This file is the entry point to configure your own services.
# Files in the packages/ subdirectory configure your dependencies.

# Put parameters here that don't need to change on each machine where the app is deployed
# https://symfony.com/doc/current/best_practices/configuration.html#application-related-configuration
parameters:
    uploads_directory: '%kernel.project_dir%/public/uploads/'
    locale: 'en'
    email_sender : 'dev1@interactions.tn'
    app_locales: en|fr|ar


services:
    # default configuration for services in *this* file
    _defaults:
        autowire: true      # Automatically injects dependencies in your services.
        autoconfigure: true # Automatically registers your services as commands, event subscribers, etc.
        public: true



    # makes classes in src/ available to be used as services
    # this creates a service per class whose id is the fully-qualified class name
    App\:
        resource: '../src/*'
        exclude: '../src/{DependencyInjection,Entity,Migrations,Tests,Kernel.php}'

    # controllers are imported separately to make sure services can be injected
    # as action arguments even if you don't extend any base controller class
    App\Controller\:
        resource: '../src/Controller'
        tags: ['controller.service_arguments']

    # add more service definitions when explicit configuration is needed
    # please note that last definitions always *replace* previous ones

    App\EventListener\FileUploadListener:
        tags:
            - { name: doctrine.event_listener, event: prePersist }
            - { name: doctrine.event_listener, event: preUpdate }


    Knp\Bundle\PaginatorBundle\Helper\Processor: '@knp_paginator.helper.processor'

    before_request_listener:
        class: App\EventListener\BeforeRequestListener
        arguments: ["@doctrine.orm.entity_manager"]
        tags:
            - name: kernel.event_listener
              event: kernel.request
              method: onKernelRequest

    before_doctrine_listener:
        class:  App\EventListener\DoctrineListenerService
        tags:
            - { name: doctrine.event_listener, event: preUpdate }
            - { name: doctrine.event_listener, event: prePersist }

    App\EventListener\AddCountryUserListener:
        tags:
            - { name: doctrine.event_listener, event: prePersist }

    App\EventListener\EncodePasswordListener:
        autowire: true
        tags:
            - { name: doctrine.event_listener, event: prePersist }
            - { name: doctrine.event_listener, event: preUpdate }

